Index: /trunk/sources/HeuristicLab.DataAccess.ADOHelper/3.2/ManyToManyRelation.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess.ADOHelper/3.2/ManyToManyRelation.cs	(revision 1655)
+++ /trunk/sources/HeuristicLab.DataAccess.ADOHelper/3.2/ManyToManyRelation.cs	(revision 1656)
@@ -8,4 +8,6 @@
   public class ManyToManyRelation: PersistableObject {
     public Guid Id2 { get; set; }
+
+    public IList<object> AdditionalAttributes { get; set; }
   }
 }
Index: /trunk/sources/HeuristicLab.DataAccess.ADOHelper/3.2/ManyToManyRelationHelper.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess.ADOHelper/3.2/ManyToManyRelationHelper.cs	(revision 1655)
+++ /trunk/sources/HeuristicLab.DataAccess.ADOHelper/3.2/ManyToManyRelationHelper.cs	(revision 1656)
@@ -22,8 +22,15 @@
     }
 
-    public void UpdateRelationships(Guid objectA, IList<Guid> relationships) {
+    public void UpdateRelationships(Guid objectA,
+      IList<Guid> relationships) {
+      UpdateRelationships(objectA, relationships, null);
+    }
+
+    public void UpdateRelationships(Guid objectA, 
+      IList<Guid> relationships,
+      IList<object> additionalAttributes) {
       //firstly check for created references
       IList<Guid> existing =
-        this.GetRelationships(objectA);
+        this.GetRelationships(objectA); 
 
       foreach (Guid relationship in relationships) {
@@ -33,4 +40,7 @@
           rel.Id = objectA;
           rel.Id2 = relationship;
+          if(additionalAttributes != null)
+            rel.AdditionalAttributes = 
+              new List<object>(additionalAttributes);
           
           RowT inserted = 
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ClientGroupAdapterWrapper.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ClientGroupAdapterWrapper.cs	(revision 1655)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ClientGroupAdapterWrapper.cs	(revision 1656)
@@ -24,5 +24,4 @@
 
       data.AddClientGroupRow(row);
-      TransactionalAdapter.Update(row);
 
       return row;
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ClientGroup_ResourceAdapterWrapper.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ClientGroup_ResourceAdapterWrapper.cs	(revision 1655)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/ClientGroup_ResourceAdapterWrapper.cs	(revision 1656)
@@ -25,5 +25,4 @@
 
       data.AddClientGroup_ResourceRow(row);
-      TransactionalAdapter.Update(row);
 
       return row;
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/RequiredPluginsAdapterWrapper.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/RequiredPluginsAdapterWrapper.cs	(revision 1655)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/TableAdapterWrapper/RequiredPluginsAdapterWrapper.cs	(revision 1656)
@@ -25,5 +25,4 @@
 
       data.AddRequiredPluginsRow(row);
-      TransactionalAdapter.Update(row);
 
       return row;
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs	(revision 1655)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/DbTestApp.cs	(revision 1656)
@@ -152,4 +152,51 @@
     }
 
+    private void InsertTestClientGroups() {
+      ISessionFactory factory =
+        ServiceLocator.GetSessionFactory();
+
+      ISession session =
+        factory.GetSessionForCurrentThread();
+
+      ITransaction trans = null;
+
+      try {
+        IClientGroupAdapter clientGroupAdapter =
+        session.GetDataAdapter<ClientGroup, IClientGroupAdapter>();
+
+        trans =
+          session.BeginTransaction();
+
+        ClientInfo client =
+          new ClientInfo();
+        client.Name = "Stefan";
+        client.Login = DateTime.Now;
+
+        ClientInfo client2 =
+          new ClientInfo();
+        client2.Name = "Martin";
+        client2.Login = DateTime.Now;
+
+        ClientGroup group =
+          new ClientGroup();
+        group.Name = "Gruppe1";
+
+        ClientGroup subGroup =
+          new ClientGroup();
+        subGroup.Name = "Untergruppe1";
+        subGroup.Resources.Add(client);
+
+        group.Resources.Add(client2);
+        group.Resources.Add(subGroup);
+
+        clientGroupAdapter.Update(group);
+
+        trans.Commit();
+      }
+      finally {
+        session.EndSession();
+      }
+    }
+
    /* private void TestJobAdapter() {
       IJobAdapter jobAdapter = 
@@ -244,4 +291,5 @@
     public override void Run() {
       TestClientGroupAdapter();
+      //InsertTestClientGroups();
     }      
   }
Index: /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/HLUserAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/HLUserAdapter.cs	(revision 1656)
+++ /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/HLUserAdapter.cs	(revision 1656)
@@ -0,0 +1,106 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.DataAccess.ADOHelper;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+using HeuristicLab.Security.DataAccess;
+using HeuristicLab.Security.ADODataAccess.TableAdapterWrapper;
+
+namespace HeuristicLab.Security.ADODataAccess {
+  class HLUserAdapter: DataAdapterBase<
+      dsSecurityTableAdapters.HLUserTableAdapter, 
+      User, 
+      dsSecurity.HLUserRow>,
+      IUserAdapter {
+    public HLUserAdapter() :
+      base(new HLUserAdapterWrapper()) {
+    }
+
+    private IPermissionOwnerAdapter permOwnerAdapter = null;
+
+    private IPermissionOwnerAdapter PermOwnerAdapter {
+      get {
+        if (permOwnerAdapter == null)
+          permOwnerAdapter =
+            this.Session.GetDataAdapter<PermissionOwner, IPermissionOwnerAdapter>();
+
+        return permOwnerAdapter;
+      }
+    }
+
+    protected override dsSecurity.HLUserRow ConvertObj(User user, dsSecurity.HLUserRow row) {
+      if (user != null && row != null) {
+        row.PermissionOwnerId = user.Id;
+
+        return row;
+      } else {
+        return null;
+      }
+    }
+
+    protected override User ConvertRow(dsSecurity.HLUserRow row, User user) {
+      if (user != null && row != null) {
+        /*Parent - permissionOwner*/
+        user.Id = row.PermissionOwnerId;
+        PermOwnerAdapter.GetById(user);
+
+        if (!row.IsLoginNull())
+          user.Login = row.Login;
+        else
+          user.Login = String.Empty;
+
+        if (!row.IsPasswordNull())
+          user.Password = row.Password;
+        else
+          user.Password = String.Empty;
+
+        if (!row.IsMailAddressNull())
+          user.MailAddress = row.MailAddress;
+        else
+          user.MailAddress = String.Empty;
+
+        return user;
+      } else {
+        return null;
+      }
+    }
+
+    #region IUserAdapter Members
+
+    protected override void doUpdate(User user) {
+      if (user != null) {
+        PermOwnerAdapter.Update(user);
+
+        base.doUpdate(user);
+      }
+    }
+
+    protected override bool doDelete(User user) {
+      bool success = false;
+
+      if (user != null) {
+        dsSecurity.HLUserRow row =
+          GetRowById(user.Id);
+
+        if (row != null) {
+          success = base.doDelete(user) &&
+            PermOwnerAdapter.Delete(user);
+        }
+      }
+
+      return success;
+    }
+
+    public User GetByName(string name)
+    {
+      User user = new User();
+      PermissionOwner permOwner =
+        PermOwnerAdapter.GetByName(name);
+
+      return GetById(permOwner.Id);
+    }
+
+    #endregion
+}
+}
Index: /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/HeuristicLab.Security.ADODataAccess-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/HeuristicLab.Security.ADODataAccess-3.2.csproj	(revision 1655)
+++ /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/HeuristicLab.Security.ADODataAccess-3.2.csproj	(revision 1656)
@@ -9,5 +9,5 @@
     <OutputType>Library</OutputType>
     <AppDesignerFolder>Properties</AppDesignerFolder>
-    <RootNamespace>HeuristicLab.Security.ADODataAccess_3._2</RootNamespace>
+    <RootNamespace>HeuristicLab.Security.ADODataAccess</RootNamespace>
     <AssemblyName>HeuristicLab.Security.ADODataAccess-3.2</AssemblyName>
     <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
@@ -74,4 +74,8 @@
   <ItemGroup>
     <Compile Include="ADODataAccessPlugin.cs" />
+    <Compile Include="TableAdapterWrapper\PermissionOwner_UserGroupAdapterWrapper.cs" />
+    <Compile Include="UserGroupAdapter.cs" />
+    <Compile Include="HLUserAdapter.cs" />
+    <Compile Include="PermissionOwnerAdapter.cs" />
     <Compile Include="dsSecurity.Designer.cs">
       <AutoGen>True</AutoGen>
@@ -79,4 +83,5 @@
       <DependentUpon>dsSecurity.xsd</DependentUpon>
     </Compile>
+    <Compile Include="PermissionAdapter.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
@@ -85,4 +90,8 @@
       <DependentUpon>Settings.settings</DependentUpon>
     </Compile>
+    <Compile Include="TableAdapterWrapper\UserGroupAdapterWrapper.cs" />
+    <Compile Include="TableAdapterWrapper\HLUserAdapterWrapper.cs" />
+    <Compile Include="TableAdapterWrapper\PermissionOwnerAdapterWrapper.cs" />
+    <Compile Include="TableAdapterWrapper\PermissionAdapterWrapper.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -98,4 +107,8 @@
       <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
       <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Security.Contracts\3.2\HeuristicLab.Security.Contracts-3.2.csproj">
+      <Project>{D59E852C-F205-4647-8C05-EB9ED1CF44E9}</Project>
+      <Name>HeuristicLab.Security.Contracts-3.2</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Security.DataAccess\3.2\HeuristicLab.Security.DataAccess-3.2.csproj">
Index: /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/PermissionAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/PermissionAdapter.cs	(revision 1656)
+++ /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/PermissionAdapter.cs	(revision 1656)
@@ -0,0 +1,81 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.DataAccess.ADOHelper;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+using HeuristicLab.Security.DataAccess;
+using HeuristicLab.Security.ADODataAccess.TableAdapterWrapper;
+
+namespace HeuristicLab.Security.ADODataAccess {
+  class PermissionAdapter: DataAdapterBase<
+      dsSecurityTableAdapters.PermissionTableAdapter, 
+      Permission, 
+      dsSecurity.PermissionRow>,
+      IPermissionAdapter {
+    public PermissionAdapter() :
+      base(new PermissionAdapterWrapper()) {
+    }
+
+    protected override dsSecurity.PermissionRow ConvertObj(Permission perm, 
+      dsSecurity.PermissionRow row) {
+      if (row != null && perm != null) {
+        row.PermissionId = perm.Id;
+        row.Name = perm.Name;
+        row.Description = perm.Description;
+        row.Plugin = perm.Plugin;
+
+        return row;
+      } else {
+        return null;
+      }
+    }
+
+    protected override Permission ConvertRow(dsSecurity.PermissionRow row,
+      Permission perm) {
+      if (row != null && perm != null) {
+        perm.Id = row.PermissionId;
+        if (!row.IsNameNull())
+          perm.Name = row.Name;
+        else
+          perm.Name = String.Empty;
+
+        if (!row.IsDescriptionNull())
+          perm.Description = row.Description;
+        else
+          perm.Description = String.Empty;
+
+        if (!row.IsPluginNull())
+          perm.Plugin = row.Plugin;
+        else
+          perm.Plugin = String.Empty;
+
+        return perm;
+      } else {
+        return null;
+      }
+    }
+
+    #region IPermissionAdapter Members
+
+    public GrantedPermission getPermission(PermissionOwner permissionOwner, 
+      Permission permission, 
+      Guid entityId) {
+      throw new NotImplementedException();
+    }
+
+    public bool grantPermission(Guid permissionOwnerId, 
+      Guid permissionId, 
+      Guid entityId) {
+      throw new NotImplementedException();
+    }
+
+    public bool revokePermission(Guid permissionOwnerId, 
+      Guid permissionId, 
+      Guid entityId) {
+      throw new NotImplementedException();
+    }
+
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/PermissionOwnerAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/PermissionOwnerAdapter.cs	(revision 1656)
+++ /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/PermissionOwnerAdapter.cs	(revision 1656)
@@ -0,0 +1,140 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.DataAccess.ADOHelper;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+using HeuristicLab.Security.DataAccess;
+using HeuristicLab.Security.ADODataAccess.TableAdapterWrapper;
+
+namespace HeuristicLab.Security.ADODataAccess {
+  class PermissionOwnerAdapter: DataAdapterBase<
+      dsSecurityTableAdapters.PermissionOwnerTableAdapter, 
+      PermissionOwner, 
+      dsSecurity.PermissionOwnerRow>,
+      IPermissionOwnerAdapter {
+    public PermissionOwnerAdapter() : 
+      base(new PermissionOwnerAdapterWrapper()) {
+    }
+
+    private IUserAdapter userAdapter = null;
+
+    private IUserAdapter UserAdapter {
+      get {
+        if (userAdapter == null)
+          userAdapter =
+            this.Session.GetDataAdapter<User, IUserAdapter>();
+
+        return userAdapter;
+      }
+    }
+
+    private IUserGroupAdapter userGroupAdapter = null;
+
+    private IUserGroupAdapter UserGroupAdapter {
+      get {
+        if (userGroupAdapter == null)
+          userGroupAdapter =
+            this.Session.GetDataAdapter<UserGroup, IUserGroupAdapter>();
+
+        return userGroupAdapter;
+      }
+    }
+
+    protected override dsSecurity.PermissionOwnerRow ConvertObj(PermissionOwner permOwner, 
+      dsSecurity.PermissionOwnerRow row) {
+      if (row != null && permOwner != null) {
+        row.PermissionOwnerId = permOwner.Id;
+        row.Name = permOwner.Name;
+
+        return row;
+      } else {
+        return null;
+      }
+    }
+
+    protected override PermissionOwner ConvertRow(dsSecurity.PermissionOwnerRow row,
+      PermissionOwner permOwner) {
+      if (row != null && permOwner != null) {
+        permOwner.Id = row.PermissionOwnerId;
+
+        if (!row.IsNameNull())
+          permOwner.Name = row.Name;
+        else
+          permOwner.Name = String.Empty;
+
+        return permOwner;
+      } else {
+        return null;
+      }
+    }
+
+    #region IPermissionOwnerAdapter Members
+
+    public PermissionOwner GetByName(string name) {
+      return base.FindSingle(
+        delegate() {
+          return Adapter.GetDataByName(name);
+        });
+    }
+
+    public bool GetById(PermissionOwner permOwner) {
+      if (permOwner != null) {
+        dsSecurity.PermissionOwnerRow row =
+          GetRowById(permOwner.Id);
+
+        if (row != null) {
+          Convert(row, permOwner);
+
+          return true;
+        }
+      }
+
+      return false;
+    }
+
+    #endregion
+
+    #region IPolymorphicDataAdapter<PermissionOwner> Members
+
+    public void UpdatePolymorphic(PermissionOwner obj) {
+      if (obj is User) {
+        UserAdapter.Update(obj as User);
+      } else if (obj is UserGroup) {
+        UserGroupAdapter.Update(obj as UserGroup);
+      } else {
+        this.Update(obj);
+      }
+    }
+
+    public PermissionOwner GetByIdPolymorphic(Guid id) {
+      UserGroup group =
+        UserGroupAdapter.GetById(id);
+
+      if (group != null)
+        return group;
+      else {
+        User user =
+          UserAdapter.GetById(id);
+
+        if (user != null)
+          return user;
+        else {
+          return this.GetById(id);
+        }
+      }
+    }
+
+    public bool DeletePolymorphic(PermissionOwner obj) {
+      if (obj is User) {
+        return UserAdapter.Delete(obj as User);
+      } else if (obj is UserGroup) {
+        return UserGroupAdapter.Delete(obj as UserGroup);
+      } else {
+        return this.Delete(obj);
+      }
+    }
+
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/Properties/Settings.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/Properties/Settings.Designer.cs	(revision 1655)
+++ /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/Properties/Settings.Designer.cs	(revision 1656)
@@ -9,5 +9,5 @@
 //------------------------------------------------------------------------------
 
-namespace HeuristicLab.Security.ADODataAccess_3._2.Properties {
+namespace HeuristicLab.Security.ADODataAccess.Properties {
     
     
Index: /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/HLUserAdapterWrapper.cs
===================================================================
--- /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/HLUserAdapterWrapper.cs	(revision 1656)
+++ /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/HLUserAdapterWrapper.cs	(revision 1656)
@@ -0,0 +1,50 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.DataAccess.ADOHelper;
+using System.Data.SqlClient;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+using System.Data.Common;
+
+namespace HeuristicLab.Security.ADODataAccess.TableAdapterWrapper {
+  class HLUserAdapterWrapper :
+   TableAdapterWrapperBase<
+       dsSecurityTableAdapters.HLUserTableAdapter,
+       User,
+       dsSecurity.HLUserRow> {
+    public override void UpdateRow(dsSecurity.HLUserRow row) {
+      TransactionalAdapter.Update(row);
+    }
+
+    public override dsSecurity.HLUserRow
+      InsertNewRow(User user) {
+      dsSecurity.HLUserDataTable data =
+        new dsSecurity.HLUserDataTable();
+
+      dsSecurity.HLUserRow row = data.NewHLUserRow();
+      row.PermissionOwnerId = user.Id;
+      data.AddHLUserRow(row);
+
+      return row;
+    }
+
+    public override IEnumerable<dsSecurity.HLUserRow>
+      FindById(Guid id) {
+      return TransactionalAdapter.GetDataById(id);
+    }
+
+    public override IEnumerable<dsSecurity.HLUserRow>
+      FindAll() {
+      return TransactionalAdapter.GetData();
+    }
+
+    protected override void SetConnection(DbConnection connection) {
+      adapter.Connection = connection as SqlConnection;
+    }
+
+    protected override void SetTransaction(DbTransaction transaction) {
+      adapter.Transaction = transaction as SqlTransaction;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/PermissionAdapterWrapper.cs
===================================================================
--- /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/PermissionAdapterWrapper.cs	(revision 1656)
+++ /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/PermissionAdapterWrapper.cs	(revision 1656)
@@ -0,0 +1,50 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.DataAccess.ADOHelper;
+using System.Data.SqlClient;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+using System.Data.Common;
+
+namespace HeuristicLab.Security.ADODataAccess.TableAdapterWrapper {
+  class PermissionAdapterWrapper :
+   TableAdapterWrapperBase<
+       dsSecurityTableAdapters.PermissionTableAdapter,
+       Permission,
+       dsSecurity.PermissionRow> {
+    public override void UpdateRow(dsSecurity.PermissionRow row) {
+      TransactionalAdapter.Update(row);
+    }
+
+    public override dsSecurity.PermissionRow
+      InsertNewRow(Permission permission) {
+      dsSecurity.PermissionDataTable data =
+        new dsSecurity.PermissionDataTable();
+
+      dsSecurity.PermissionRow row = data.NewPermissionRow();
+      row.PermissionId = permission.Id;
+      data.AddPermissionRow(row);
+
+      return row;
+    }
+
+    public override IEnumerable<dsSecurity.PermissionRow>
+      FindById(Guid id) {
+      return TransactionalAdapter.GetDataById(id);
+    }
+
+    public override IEnumerable<dsSecurity.PermissionRow>
+      FindAll() {
+      return TransactionalAdapter.GetData();
+    }
+
+    protected override void SetConnection(DbConnection connection) {
+      adapter.Connection = connection as SqlConnection;
+    }
+
+    protected override void SetTransaction(DbTransaction transaction) {
+      adapter.Transaction = transaction as SqlTransaction;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/PermissionOwnerAdapterWrapper.cs
===================================================================
--- /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/PermissionOwnerAdapterWrapper.cs	(revision 1656)
+++ /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/PermissionOwnerAdapterWrapper.cs	(revision 1656)
@@ -0,0 +1,50 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.DataAccess.ADOHelper;
+using System.Data.SqlClient;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+using System.Data.Common;
+
+namespace HeuristicLab.Security.ADODataAccess.TableAdapterWrapper {
+  class PermissionOwnerAdapterWrapper :
+   TableAdapterWrapperBase<
+       dsSecurityTableAdapters.PermissionOwnerTableAdapter,
+       PermissionOwner,
+       dsSecurity.PermissionOwnerRow> {
+    public override void UpdateRow(dsSecurity.PermissionOwnerRow row) {
+      TransactionalAdapter.Update(row);
+    }
+
+    public override dsSecurity.PermissionOwnerRow
+      InsertNewRow(PermissionOwner permission) {
+      dsSecurity.PermissionOwnerDataTable data =
+        new dsSecurity.PermissionOwnerDataTable();
+
+      dsSecurity.PermissionOwnerRow row = data.NewPermissionOwnerRow();
+      row.PermissionOwnerId = permission.Id;
+      data.AddPermissionOwnerRow(row);
+
+      return row;
+    }
+
+    public override IEnumerable<dsSecurity.PermissionOwnerRow>
+      FindById(Guid id) {
+      return TransactionalAdapter.GetDataById(id);
+    }
+
+    public override IEnumerable<dsSecurity.PermissionOwnerRow>
+      FindAll() {
+      return TransactionalAdapter.GetData();
+    }
+
+    protected override void SetConnection(DbConnection connection) {
+      adapter.Connection = connection as SqlConnection;
+    }
+
+    protected override void SetTransaction(DbTransaction transaction) {
+      adapter.Transaction = transaction as SqlTransaction;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/PermissionOwner_UserGroupAdapterWrapper.cs
===================================================================
--- /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/PermissionOwner_UserGroupAdapterWrapper.cs	(revision 1656)
+++ /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/PermissionOwner_UserGroupAdapterWrapper.cs	(revision 1656)
@@ -0,0 +1,52 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.DataAccess.ADOHelper;
+using System.Data.SqlClient;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+using System.Data.Common;
+
+namespace HeuristicLab.Security.ADODataAccess.TableAdapterWrapper {
+  class PermissionOwner_UserGroupAdapterWrapper :
+   TableAdapterWrapperBase<
+       dsSecurityTableAdapters.PermissionOwner_UserGroupTableAdapter,
+       ManyToManyRelation,
+       dsSecurity.PermissionOwner_UserGroupRow> {
+    public override void UpdateRow(dsSecurity.PermissionOwner_UserGroupRow row) {
+      TransactionalAdapter.Update(row);
+    }
+
+    public override dsSecurity.PermissionOwner_UserGroupRow
+      InsertNewRow(ManyToManyRelation relation) {
+      dsSecurity.PermissionOwner_UserGroupDataTable data =
+        new dsSecurity.PermissionOwner_UserGroupDataTable();
+
+      dsSecurity.PermissionOwner_UserGroupRow row = data.NewPermissionOwner_UserGroupRow();
+      row.UserGroupId = relation.Id;
+      row.PermissionOwnerId = relation.Id2;
+
+      data.AddPermissionOwner_UserGroupRow(row);
+
+      return row;
+    }
+
+    public override IEnumerable<dsSecurity.PermissionOwner_UserGroupRow>
+      FindById(Guid id) {
+      return TransactionalAdapter.GetDataByUserGroupId(id);
+    }
+
+    public override IEnumerable<dsSecurity.PermissionOwner_UserGroupRow>
+      FindAll() {
+      return TransactionalAdapter.GetData();
+    }
+
+    protected override void SetConnection(DbConnection connection) {
+      adapter.Connection = connection as SqlConnection;
+    }
+
+    protected override void SetTransaction(DbTransaction transaction) {
+      adapter.Transaction = transaction as SqlTransaction;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/UserGroupAdapterWrapper.cs
===================================================================
--- /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/UserGroupAdapterWrapper.cs	(revision 1656)
+++ /trunk/sources/HeuristicLab.Security.ADODataAccess/3.2/TableAdapterWrapper/UserGroupAdapterWrapper.cs	(revision 1656)
@@ -0,0 +1,50 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.DataAccess.ADOHelper;
+using System.Data.SqlClient;
+using HeuristicLab.Security.Contracts.BusinessObjects;
+using System.Data.Common;
+
+namespace HeuristicLab.Security.ADODataAccess.TableAdapterWrapper {
+  class UserGroupAdapterWrapper :
+   TableAdapterWrapperBase<
+       dsSecurityTableAdapters.UserGroupTableAdapter,
+       UserGroup,
+       dsSecurity.UserGroupRow> {
+    public override void UpdateRow(dsSecurity.UserGroupRow row) {
+      TransactionalAdapter.Update(row);
+    }
+
+    public override dsSecurity.UserGroupRow
+      InsertNewRow(UserGroup group) {
+      dsSecurity.UserGroupDataTable data =
+        new dsSecurity.UserGroupDataTable();
+
+      dsSecurity.UserGroupRow row = data.NewUserGroupRow();
+      row.PermissionOwnerId = group.Id;
+      data.AddUserGroupRow(row);
+
+      return row;
+    }
+
+    public override IEnumerable<dsSecurity.UserGroupRow>
+      FindById(Guid id) {
+      return TransactionalAdapter.GetDataById(id);
+    }
+
+    public override IEnumerable<dsSecurity.UserGroupRow>
+      FindAll() {
+      return TransactionalAdapter.GetData();
+    }
+
+    protected override void SetConnection(DbConnection connection) {
+      adapter.Connection = connection as SqlConnection;
+    }
+
+    protected override void SetTransaction(DbTransaction transaction) {
+      adapter.Transaction = transaction as SqlTransaction;
+    }
+  }
+}
